
#include <stdio.h>
#include "micro_frc.h"
//#include "servo.h"
#include "uart1.h"
#include "timer.h"
#include "sensor_spi.h"
#include "ahrs.h"
//#include "vqm_lib.h"
#include "adc.h"
#include "hmc5843.h"
#include <math.h>



v_t			angles; // angles from kalman process
v_t			angles_est;	// angles from estimator
v_t			gbias; //bias
v_t			q1; // quaternion to display
v_t			q2;


int main ()
{			
	float dt; // loop time in seconds
	int i; //for loops

	microcontroller_init();
	
	init_timer4(); //used for dt

	uart1_open(57600);

	InitI2C();				// Initialize the I2C(1) module
	init_HMC5843();			// initialize the HMC5843 chip
	adc_open();
	
	update_mag();
	adc_start();
	microcontroller_delay_ms(10);
	
	ahrs_init();  		// initialize EKF parameters

	dt = dt_seconds();	// initialize dt

	while (1)			// main loop
	{

		for (i=0; i < 10; i++) 			// loop and do 10 kalman time updates
		{
			dt = dt_seconds();
			adc_start();
			microcontroller_delay_ms(3);
			time_update(dt); //kalman time update
				
		}

		update_mag(); 			// update magnetometer buffer
		estimator_update();		// update sensor estimated attitude
		measurement_update();	// do kalman measurement update

		getangles(angles);		// retrieve attitude angles from ahrs
		getestimator(angles_est);
		//getbias(gbias);
		getqstate(q1);
		getqhat(q2);
				
			printf( "p%9.3f %9.3f %9.3f %9.3f %9.3f %9.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f %6.3f\n\r",
			angles_est[0],
			angles_est[1],
			angles_est[2],
			angles[0],
			angles[1],
			angles[2],
			//gbias[0],
			//gbias[1],
			//gbias[2]
			q1[0],
			q1[1],
			q1[2],
			q1[3],
			q2[0],
			q2[1],
			q2[2],
			q2[3]				
			);			

	
	} 	// end while


	return 0 ;
} 		// end main
	
