/*! 
 *  @file     microcontroller.h
 *  @brief    To be included by every file that would use the microcontroller's hardware
 *  @detailed This takes case of the initialization of the microcontroller (PLL, XT). Also
 *            contains delay functions and traps.
 *  @author   Tom Pycke
 *  @date     23-nov-2008
 *  @since    0.1
 *
 *	note - uses internal FRC Mitch
 */

#include <p33FJ256MC710.h>
 
#define FOSC 7372800*43/(2*2)   // We're using FRC * m/(n1*n2)
//#define PLL  16           	// PLL configuration
#define FCY  FOSC/2    			// Resulting Fcy for a dsPic33


void microcontroller_init();

void microcontroller_delay_us(unsigned long us);
void microcontroller_delay_ms(unsigned long ms);
int microcontroller_after_reboot();
