// sensor_spi.h

# include "spi.h" // include header for spi library


//accelerometers

float accelero_x(void);
float accelero_y(void);
float accelero_z(void);


int ax_raw(void);
int ax_filtered(void);
int ay_raw(void);
int ay_filtered(void);
int az_raw(void);
int az_filtered(void);

// gyros
float gyro_roll_dps(void); 		// deg per sec
float gyro_roll_rps(void);		// rad per sec
float gyro_pitch_dps(void);
float gyro_pitch_rps(void);
float gyro_yaw_dps(void);
float gyro_yaw_rps(void);



int p_raw(void);
int p_filtered(void);
int q_raw(void);
int q_filtered(void);
int yaw_raw(void);
int yaw_filtered(void);

float rad_to_deg(float inrad);

float deg_to_rad(float indeg);



void update_sensors(void);
void init_spi();

void start_mlx1(void);
void start_mlx2(void);
void start_mlx3(void);

int read_mlx1(void);
int read_mlx2(void);
int read_mlx3(void);

void init_lis(void);

int read_lis_x(void);
int read_lis_y(void);
int read_lis_z(void);

char read_lis_register(char register_name);
void write_lis_register(char register_name, char register_value);
//char spi_comm(char outgoing_byte);

unsigned int ReadSPI();

void WriteSPI(unsigned int data_out);

