// timer.c

#include "micro_frc.h"

static const float ticks_per_second = (float)FCY;

void init_timer1()
{
	T1CONbits.TCS = 0;   // Internal clock (FOSC/4)
	T1CONbits.TCKPS = 0; // No prescaler
	T1CONbits.TON = 1;
	//TMR1 = 0;            // Reset counter
}


void init_timer2() 	//2 and 3 are combined
					// set up now - dont start or enable interrupt
{	T2CON=0;              	// turn off for now
	T2CONbits.T32=0;		// not 32 bit
	T2CONbits.TCS = 0;   	// Internal clock (FOSC/4)
	T2CONbits.TCKPS = 0; 	// No prescaler
	IEC0bits.T2IE  = 0;		// disable the interrupt for now
	IPC1bits.T2IP = 4 ;     // priority 5 ???
}

void init_timer4() //4 and 5 are combined
{	T4CON=0;              // turn off for now
	T5CON=0;
	TMR4=0;
	TMR5=0;
	T4CONbits.T32=1;		// 32 bit
	T4CONbits.TCS = 0;   // Internal clock (FOSC/2)
	T5CONbits.TCS = 0;
	T4CONbits.TCKPS = 0; // no prescaler 
	T4CONbits.TON = 1;			// turn on
}

void reset_timer4() //4 and 5 are combined
{	
	T4CONbits.TON = 0;			// turn off
	TMR4=0;
	TMR5=0;
	T4CONbits.TON = 1;			// turn on
}



float dt_seconds() 	// Returns the time in seconds since the last call 
					// of this function (or last reset)
{
	long t = TMR5;
	t <<= 16;
	t += TMR4;
	//t <<= 8;       // we use a 1/256 prescaler!
	float dtsec = (float)t/ticks_per_second;
	reset_timer4();	
	return dtsec;
}

